;;==========================================================================;; 
;; Joe Zbiciak's Space Patrol for Intellivision.                            ;;
;; Copyright 2007, Joe Zbiciak, intvnut AT gmail.com.                       ;;
;; http://spatula-city.org/~im14u2c/intv/                                   ;;
;;==========================================================================;;

;;==========================================================================;;
;;  TWINKLE -- Twinkles the stars in the sky.                               ;;
;;==========================================================================;;
TWINKLE     PROC
            PSHR    R5
           
            CALL    RAND
           
            MOVR    R0,     R3
            ANDI    #$FF,   R0
           
            CMPI    #60,    R0
            BGE     @@done
           
            MVII    #$200,  R2
            ADDR    R0,     R2
           
            ANDI    #$700,  R3
            BEQ     @@toggle
            CLRR    R1
            B       @@clear

@@toggle:
            MVI     RSEED,  R0
            ANDI    #3,     R0

            MVII    #@@tbl, R1
            ADDR    R0,     R1
            MVI@    R1,     R1
           
            XOR@    R2,     R1
            MOVR    R1,     R3
            ANDI    #$FF*8, R3
            BNEQ    @@ok
            XOR@    R2,     R1
@@ok:
@@clear:
            MVO@    R1,     R2
           
@@done:     PULR    PC
           
@@tbl:      DECLE   $2B*8 + X_TAN + $800
            DECLE   $2B*8 + X_CYN + $800
            DECLE   $2B*8 + X_YGR + $800
            DECLE   $2B*8 + X_GRY + $800
            ENDP

__
;* ======================================================================== *;
;*  This program is free software; you can redistribute it and/or modify    *;
;*  it under the terms of the GNU General Public License as published by    *;
;*  the Free Software Foundation; either version 2 of the License, or       *;
;*  (at your option) any later version.                                     *;
;*                                                                          *;
;*  This program is distributed in the hope that it will be useful,         *;
;*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *;
;*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *;
;*  General Public License for more details.                                *;
;*                                                                          *;
;*  You should have received a copy of the GNU General Public License       *;
;*  along with this program; if not, write to the Free Software             *;
;*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               *;
;* ======================================================================== *;
;*                   Copyright (c) 2007, Joseph Zbiciak                     *;
;* ======================================================================== *;
_
